/* Copyright (c) 2009, Delft University of Technology

    This file is part of the MEGS package.

    The MEGS pakcage is free software: you can redistribute it
    and/or modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    The MEGS pakcage is distributed in the hope that it will be
    useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with the MEGS package.  If not, see
    <http://www.gnu.org/licenses/>.
*/
package engine;

/**
 * @author menno
 * The main engine that controls all the processes.
 */
public class Engine {
	EventReader reader;
	SystemStatus status;
	public Engine(EventReader reader, SystemStatus status)
	{
		this.reader = reader;
		this.status = status;
	}
	
	public void run()
	{
		//init the system.
		status.init();
		
		while(reader.hasMoreEvents())
		{
			Event event = reader.nextEvent();
			if(event != null)
			{
				//System.out.println("Event: " + event);
				status.processEvent(event);
			}
			else
			{
				System.out.println("No events left!!!!");
			}
		}
		
		status.end();
		
		System.out.println("Exiting status:");
		System.out.println(status.fullReport());
		System.out.println(status.getAssertStatus());
		System.out.println(status.errorReport());
	}
}
