/* Copyright (c) 2009, Delft University of Technology

    This file is part of the MEGS package.

    The MEGS pakcage is free software: you can redistribute it
    and/or modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    The MEGS pakcage is distributed in the hope that it will be
    useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with the MEGS package.  If not, see
    <http://www.gnu.org/licenses/>.
*/
package engine;

/**
 * A class to put all the constants the represent settings in one usefull place
 * 
 */
public class Settings {
	
	/**
	 * If the parsing takes too long, put this on true. This will 
	 * increase the speed a lot (5x faster is normal).
	 * The downside is that the unknown events do update the 
	 * time a node has last responded, thus this will decrease the 
	 * precision of the response check. 
	 */
	public static boolean IGNORE_UNKNOWN_EVENTS = false;
	
	/**
	 * The amount of seconds without response from a node before assuming it died or stopped responding
	 */
	public static double DEATH_CHECK = 4.5;
	
	/**
	 * The maximum amount of time a messages take to be sent
	 * this is used to limit the  send events that could match 
	 * with a receive event, the time used is the logged time. 
	 * Time is in seconds.
	 * For TOSSIM 0.025 hardly ever gives any errors, but for testbed 0.1 or 1 is better
	 */
	public static double MESSAGE_TIME = 1;
	
	/**
	 * The file to plot the data to 
	 */
	public static String PLOT_FILE = "systemplot.data";
	
	/**
	 * If true unmatched errors are shown. 
	 */
	public static boolean SHOW_MESSAGE_ERRORS = false;
}
