/* Copyright (c) 2009, Delft University of Technology

    This file is part of the MEGS package.

    The MEGS pakcage is free software: you can redistribute it
    and/or modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    The MEGS pakcage is distributed in the hope that it will be
    useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with the MEGS package.  If not, see
    <http://www.gnu.org/licenses/>.
*/
package mintroute;

import java.text.DecimalFormat;
import engine.*;

public class MintNode extends Node {

	// the number outputted if no parent is selected
	public final int defaultParent = 255;

	private int hopcount = 255;

	private int parent = -1;

	// the signal strength of this node
	private int power = 128;

	private int parentSwitches = 0;

	public MintNode(int n, SystemStatus s) {
		super(n, s);
	}

	public String toString() {
		DecimalFormat df = new DecimalFormat("#.###");
		String deadString = "";
		if (isDead()) {
			deadString = "(dead)";
		}
		return number + " : hops=" + +getHopcount() + ", parent=" + getParent()
				+ " ( " + parentSwitches + " switches), last activity="
				+ df.format(lastActivity) + " s " + sendEvents.size() + " "
				+ deadString;
	}

	public void setParent(int parent) {
		// only count switches to real parents
		if (parent != defaultParent) {
			parentSwitches++;
		}
		this.parent = parent;
	}

	public int getParent() {
		return parent;
	}

	public int getParentSwitches() {
		return parentSwitches;
	}

	public void setHopcount(int hopcount) {
		this.hopcount = hopcount;
	}

	public int getHopcount() {
		return hopcount;
	}

	public int getPower() {
		return power;
	}

	public void setPower(int power) {
		this.power = power;
	}
}
